︠03c34d63-7b2e-4aa7-94b0-2cfb4444297b︠
Author: Vincent J. Matsko
Date: 1 November 2015, Day011
Post: Evaporation I

︡3ddc5388-4a6c-44ff-b0f8-f554ec096881︡{"done":true}︡
︠7aa6e844-1613-4d19-a8c5-7bbfdc41d4ccs︠
# Again, remember shift+enter to evaluate!

from sage.plot.colors import rgbcolor

# Makes sure r is in the correct range (that is, between 0 and 1).
# You might add or subtract to an RGB value and inadvertantly go outside the range [0,1]. 
def RGBValue (r): 
    if r < 0:
        return 0
    else:
        if r > 1:
            return 1
        else:
            return r

# Note that this routine adds the delta to the colors.  You can subtract, too (just change the code).
def RandomColor(base, delta):
    return rgbcolor([RGBValue(base[count] + delta * random()) for count in range(3)])

# As arguments, provide the width, height, color (RGB values), delta (change in the color parameters), and the random number seed.
def ColorSquare(width, height, color, delta, seed):
    squares = []  # Saves the points in the final image.
    set_random_seed(seed)  # Sets the random number generator.  Using different values produces different results.
    for i in range(width):
        for j in range(height):
            # Uses the append method to add the next square.
            # This is a feature of object-oriented programming.
            squares.append(plot(polygon2d([(i,j),(i+1,j),(i+1,j+1),(i,j+1)], rgbcolor=RandomColor(color, delta))))
    # Python uses the "+" to mean many differnet things.  You can "add" graphics objects using "sum" and output them all together.
    P = sum(squares)
    show(P, aspect_ratio=1, svg=True, axes=False, xmin=-1, xmax=width+1, ymin=-1, ymax=height+1)
    # This shows you how you would save your image to a file.
    save(P, 'colorsquare.svg')
︡dcf0f3b3-2632-4157-9992-a4a3e0524a95︡{"done":true}︡
︠5f7bd21d-dbbe-4f56-b16e-9e6ddda589dbr︠
ColorSquare(20, 20, [0.0,0.2,0.9], 1, 47)
︡f2578254-6105-4573-8fd8-8f1c62f5ac78︡{"file":{"filename":"/projects/48a4f88a-5167-45ae-a54c-f4c735940fa0/.sage/temp/compute3-us/15831/tmp_gB3ffu.svg","show":true,"text":null,"uuid":"e447d74b-d5c0-4a93-bc4a-7d7394393fd3"},"once":false}︡{"html":"<div align='center'></div>"}
︠b3c43b62-2235-4a23-a62b-ebdfd8a4eefcs︠
def RandomGray(gray, delta):
    change = delta * random ();
    return rgbcolor([gray + change, gray + change, gray + change]);

# As arguments, provide the width, height, level of gray, base radius for circles, 
# change in radius, change in gray, and the random number seed.
def TextureSquare(width, height, gray, r, rdelta, cdelta, seed):
    disks = []  # Saves the points in the final image.
    set_random_seed(seed)  # Sets the random number generator.  Using different values produces different results.
    for i in range(width):
        for j in range(height):
            disks.append(plot(disk((i,j), r + rdelta * random(), (0,2*pi), rgbcolor=RandomGray(gray, cdelta))))
    P = sum(disks)
    show(P, aspect_ratio=1, svg=True, axes=False, xmin=-1, xmax=width+1, ymin=-1, ymax=height+1)
 
︡c12134cb-ac2c-4fd4-894e-189c5c39d277︡{"done":true}︡
︠4d68890e-bbe0-4ba2-a715-719611c34f8ds︠
# Example just changing the radii of the circles.
# Just make the delta 0 (sixth argument to the function) so there is no change in color.
# Note that the gray is defined by a number between 0 (black) and 1 (white).
TextureSquare(100, 100, 0.3 ,0.4, 0.3, 0.5, 44)
︡31105e84-31a2-4c5e-bc4f-2fe60758a9df︡{"file":{"filename":"/projects/48a4f88a-5167-45ae-a54c-f4c735940fa0/.sage/temp/compute3-us/21751/tmp_1Rk5Sk.svg","show":true,"text":null,"uuid":"b6107bdd-0748-4f4b-b122-eda1104de00b"},"once":false}︡{"html":"<div align='center'></div>"}︡︡{"done":true}
︠46893790-992c-427e-b745-286fb9aa05cas︠
# Example just changing the color of the circles.
# Just make the rdelta 0 (fifth argument to the function) so there is no change in radius.
TextureSquare(20, 20, 0.3 ,0.45, 0, 0.3, 42)
︡bf2a2df6-49a6-4860-9add-49f7bc07c308︡︡{"once":false,"done":false,"file":{"show":true,"uuid":"0852eab2-d2af-4a8c-8c43-f87fb59d39d4","filename":"/projects/48a4f88a-5167-45ae-a54c-f4c735940fa0/.sage/temp/compute3-us/20833/tmp_Pbks0y.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠475f4f75-5648-4db6-9b90-1ed6945d7b13s︠
# Example changing both the radius and the color of the circles.
TextureSquare(20, 20, 0.3 ,0.4, 0.1, 0.3, 42)
︡32b1f4bd-f470-4f6b-8f02-be9b07647f52︡︡{"once":false,"done":false,"file":{"show":true,"uuid":"e4ab34ee-3e8d-493c-b2c1-96ce30054285","filename":"/projects/48a4f88a-5167-45ae-a54c-f4c735940fa0/.sage/temp/compute3-us/20833/tmp_Wasx80.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠ca80e0f2-624d-4bdd-9d78-4652ee1e45c5︠









